@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S %0 %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!/usr/bin/perl
#line 15

$dbname = shift (@ARGV) || prompt("Database name");
&usage()  unless ($dbname =~ /^\w+$/);

open (SDB, ">>${dbname}.sdb")  || die "Could not open database \"${dbname}.sdb\"!\n";

if ($ARGV[0])
{
	$cryptedpswd = crypt($ARGV[1], substr($ARGV[0],0,2));
	print SDB <<END_REC;
$ARGV[2]/*$ARGV[3]
$ARGV[0]
$cryptedpswd
$ARGV[5]
$ARGV[4]
END_REC
}
else
{
	do
	{
		$dbuser = prompt("\nDatabase user");
		goto DONE  unless ($dbuser =~ /^\w+$/);
		$dbpswd = prompt("User password");
		goto DONE  unless ($dbpswd =~ /^\w+$/);
		$dbpath = prompt("Database path");
		$dbpath = '.'  unless ($dbpath);
		$dbpath =~ s#/$##;	
		$dbext  = prompt("Table file extension (default .stb)");
		$dbext = '.stb'  unless ($dbext);
		$rdelim = prompt("Record delimiter (default \\r\\n)");
		$rdelim = '\r\n'  unless ($rdelim);
		$fdelim = prompt("Field delimiter (default ::)");
		$fdelim = '::'  unless ($fdelim);
		$cryptedpswd = crypt($dbpswd, substr($dbuser,0,2));
		print SDB <<END_REC;
$dbpath/*$dbext
$dbuser
$cryptedpswd
$fdelim
$rdelim
END_REC
	}
	while (1);
}

DONE: ;

exit (0);

sub prompt
{
        my ($pmpt,$dflt) = @_;

        my ($t);
        print "$pmpt: ";

        $t = <>;
        chomp($t);
        $t = $dflt  unless ($t =~ /\S/);
        return $t;
}

sub usage
{
	print "..usage:  $0 [dbname [user password path ext rec_sep field_sep]]\n";
	print "\nCreates / adds users to a Sprite database.\n\n";
	exit (1);
}

__END__
:endofperl
